This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 810335 - Review Request: python-fabulous - Makes your terminal output totally fabulous
Review Request: python-fabulous - Makes your terminal output totally fabulous
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ian Weller
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 818293 818297
  Show dependency treegraph
 
Reported: 2012-04-05 11:47 EDT by Ralph Bean
Modified: 2012-05-26 03:47 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-05-22 11:42:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
ian: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ralph Bean 2012-04-05 11:47:40 EDT
Spec URL: http://threebean.org/rpm/python-fabulous.spec
SRPM URL: http://threebean.org/rpm/python-fabulous-0.1.5-1.fc16.src.rpm
Description:
fabulous is a python module for producing fabulously colored terminal output.

koji-f17 - http://koji.fedoraproject.org/koji/taskinfo?taskID=3966149
koji-el6 - http://koji.fedoraproject.org/koji/taskinfo?taskID=3966184

rpmlint output:
 % rpmlint SPECS/python-fabulous.spec SRPMS/python-fabulous-0.1.5-1.fc16.src.rpm RPMS/noarch/python-fabulous-0.1.5-1.fc17.noarch.rpm
python-fabulous.noarch: W: no-documentation
python-fabulous.noarch: W: devel-file-in-non-devel-package /usr/lib/python2.7/site-packages/fabulous/_xterm256.c
2 packages and 1 specfiles checked; 0 errors, 2 warnings.
Comment 1 Ian Weller 2012-04-19 19:25:37 EDT
Review checklist, last updated 2012-02-07
Based on https://fedoraproject.org/wiki/Packaging:ReviewGuidelines
Key: [X] passed, [F] failed, [-] irrelevant

[X] MUST: rpmlint must be run on the source rpm and all binary rpms the build
    produces. The output should be posted in the review.

python-fabulous.noarch: W: no-documentation
python-fabulous.noarch: W: devel-file-in-non-devel-package /usr/lib/python2.7/site-packages/fabulous/_xterm256.c

You might consider including README in %doc as well as building the Sphinx
documentation and including that in %doc.

[X] MUST: The package must be named according to the Package Naming Guidelines.
[X] MUST: The spec file name must match the base package %{name}, in the format
    %{name}.spec unless your package has an exemption.
[X] MUST: The package must be licensed with a Fedora approved license and meet
    the Licensing Guidelines.
[X] MUST: The License field in the package spec file must match the actual
    license. 
[F] MUST: If (and only if) the source package includes the text of the
    license(s) in its own file, then that file, containing the text of the
    license(s) for the package must be included in %doc.

The source tarball contains a COPYING file.

[X] MUST: The spec file must be written in American English. 
[X] MUST: The spec file for the package MUST be legible. 
[X] MUST: The sources used to build the package must match the upstream source,
    as provided in the spec URL. Reviewers should use md5sum for this task. If
    no upstream URL can be specified for this package, please see the Source
    URL Guidelines for how to deal with this.
[X] MUST: The package MUST successfully compile and build into binary rpms on
    at least one primary architecture. 
[-] MUST: If the package does not successfully compile, build or work on an
    architecture, then those architectures should be listed in the spec in
    ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed
    in bugzilla, describing the reason that the package does not
    compile/build/work on that architecture. The bug number MUST be placed in a
    comment, next to the corresponding ExcludeArch line. 
[X] MUST: All build dependencies must be listed in BuildRequires, except for
    any that are listed in the exceptions section of the Packaging Guidelines;
    inclusion of those as BuildRequires is optional. Apply common sense.
[-] MUST: The spec file MUST handle locales properly. This is done by using the
    %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[-] MUST: Every binary RPM package (or subpackage) which stores shared library
    files (not just symlinks) in any of the dynamic linker's default paths,
    must call ldconfig in %post and %postun. 
[F] MUST: Packages must NOT bundle copies of system libraries.

Not exactly a system library, but this package bundles font files, which is not
okay. See:
https://fedoraproject.org/wiki/Packaging:Guidelines#Avoid_bundling_of_fonts_in_other_packages

[-] MUST: If the package is designed to be relocatable, the packager must state
    this fact in the request for review, along with the rationalization for
    relocation of that specific package. Without this, use of Prefix: /usr is
    considered a blocker. 
[X] MUST: A package must own all directories that it creates. If it does not
    create a directory that it uses, then it should require a package which
    does create that directory. 
[X] MUST: A Fedora package must not list a file more than once in the spec
    file's %files listings. (Notable exception: license texts in specific
    situations)
[X] MUST: Permissions on files must be set properly. Executables should be set
    with executable permissions, for example. 
[X] MUST: Each package must consistently use macros. 
[X] MUST: The package must contain code, or permissable content. 
[-] MUST: Large documentation files must go in a -doc subpackage. (The
    definition of large is left up to the packager's best judgement, but is not
    restricted to size. Large can refer to either size or quantity). 
[-] MUST: If a package includes something as %doc, it must not affect the
    runtime of the application. To summarize: If it is in %doc, the program
    must run properly if it is not present. 
[-] MUST: Static libraries must be in a -static package. 
[-] MUST: Development files must be in a -devel package. 
[-] MUST: In the vast majority of cases, devel packages must require the base
    package using a fully versioned dependency:
       Requires: %{name}%{?_isa} = %{version}-%{release} 
[-] MUST: Packages must NOT contain any .la libtool archives, these must be
    removed in the spec if they are built.
[-] MUST: Packages containing GUI applications must include a %{name}.desktop
    file, and that file must be properly installed with desktop-file-install in
    the %install section. If you feel that your packaged GUI application does
    not need a .desktop file, you must put a comment in the spec file with your
    explanation. 
[X] MUST: Packages must not own files or directories already owned by other
    packages. The rule of thumb here is that the first package to be installed
    should own the files or directories that other packages may rely upon. This
    means, for example, that no package in Fedora should ever share ownership
    with any of the files or directories owned by the filesystem or man
    package. If you feel that you have a good reason to own a file or directory
    that another package owns, then please present that at package review time. 
[X] MUST: All filenames in rpm packages must be valid UTF-8. 

Please fix: COPYING file in %doc, font bundling
Comment 2 Germán Racca 2012-04-20 10:29:25 EDT
Hi Ralph,

just some quick comments:

1) Why you don't use macros in the spec file?

Instead of writing:

Source0: http://lobstertech.com/media/file/fabulous/fabulous-0.1.5.tar.gz

you should use:

Source0: http://lobstertech.com/media/file/%{modname}/%{modname}-%{version}.tar.gz

so you don't need to update this line every time you bump the sepc file and avoid compiling an old source by mistake.

2) I also don't see the definition of sitelib for noarch packages at the top of the spec file, as indicated in the template /etc/rpmdevtools/spectemplate-python.spec. Is it not needed anymore?

HTH,
Germán.
Comment 3 Ian Weller 2012-04-20 14:35:12 EDT
(In reply to comment #2)
> 2) I also don't see the definition of sitelib for noarch packages at the top of
> the spec file, as indicated in the template
> /etc/rpmdevtools/spectemplate-python.spec. Is it not needed anymore?

For all non-EOL releases of Fedora and EPEL 6, it is no longer needed.

https://fedoraproject.org/wiki/Packaging:Python#Macros

If Ralph plans to build this for EPEL 5 or lower he will need to have the sitelib definition.
Comment 4 Ralph Bean 2012-04-22 21:19:08 EDT
(In reply to comment #3) 
> If Ralph plans to build this for EPEL 5 or lower he will need to have the
> sitelib definition.

No plans to build for EPEL 5.
Comment 5 Ralph Bean 2012-04-22 21:21:22 EDT
Here is a second revision:

Spec URL: http://threebean.org/rpm/python-fabulous.spec
SRPM URL: http://threebean.org/rpm/python-fabulous-0.1.5-2.fc17.src.rpm

 - Patched out the bundled fonts.
 - Included COPYING and README in the %doc
 - Started using the modname macro at Germán Racca's suggestion.
Comment 6 Ian Weller 2012-04-22 22:06:28 EDT
There's no requirement for doing so, but you might consider building the Sphinx documentation and putting it in %doc. (Then again, it's just a bunch of autodoc declarations, so it's the same thing you'd get with pydoc on the command line. Your choice, really, if you think the HTML documentation is useful.)

rpmlint barfs:

python-fabulous.src: W: file-size-mismatch fabulous-0.1.5.tar.gz = 322526, http://lobstertech.com/media/file/fabulous/fabulous-0.1.5.tar.gz = 322052
python-fabulous.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/python-fabulous-0.1.5/README
python-fabulous.noarch: W: devel-file-in-non-devel-package /usr/lib/python2.7/site-packages/fabulous/_xterm256.c

Looks like upstream changed their source archive (blegh). Run dos2unix on README and that should fix the end of line problem. You can also just nuke _xterm256.c, it doesn't look like it's used at all and was just used as a reference for xterm256.py.
Comment 7 Ralph Bean 2012-04-22 22:29:44 EDT
(In reply to comment #6)
> There's no requirement for doing so, but you might consider building the Sphinx
> documentation and putting it in %doc. (Then again, it's just a bunch of autodoc
> declarations, so it's the same thing you'd get with pydoc on the command line.
> Your choice, really, if you think the HTML documentation is useful.)

I took a stab at it but had some trouble getting it to work with "make -C docs html".  It doesn't seem to be straightforward so I'm skipping it for now.

> python-fabulous.src: W: file-size-mismatch fabulous-0.1.5.tar.gz = 322526,
> http://lobstertech.com/media/file/fabulous/fabulous-0.1.5.tar.gz = 322052
> python-fabulous.noarch: W: wrong-file-end-of-line-encoding
> /usr/share/doc/python-fabulous-0.1.5/README
> python-fabulous.noarch: W: devel-file-in-non-devel-package
> /usr/lib/python2.7/site-packages/fabulous/_xterm256.c
> 
> Looks like upstream changed their source archive (blegh). Run dos2unix on
> README and that should fix the end of line problem. You can also just nuke
> _xterm256.c, it doesn't look like it's used at all and was just used as a
> reference for xterm256.py.

I put up a new revision that should fix those three:

Spec URL: http://threebean.org/rpm/python-fabulous.spec
SRPM URL: http://threebean.org/rpm/python-fabulous-0.1.5-3.fc17.src.rpm
Comment 8 Ralph Bean 2012-04-22 22:35:30 EDT
And yet another revision.  Got the sphinx docs to build correctly with judicious use of PYTHONPATH.

Spec URL: http://threebean.org/rpm/python-fabulous.spec
SRPM URL: http://threebean.org/rpm/python-fabulous-0.1.5-4.fc17.src.rpm
Comment 9 Ian Weller 2012-04-24 23:19:11 EDT
Looks good to me. APPROVED
Comment 10 Ralph Bean 2012-04-24 23:43:32 EDT
New Package SCM Request
=======================
Package Name: python-fabulous
Short Description: Makes your terminal output totally fabulous
Owners: ralph
Branches: f17 el6
InitialCC:
Comment 11 Jon Ciesla 2012-04-25 08:43:35 EDT
Git done (by process-git-requests).
Comment 12 Fedora Update System 2012-04-25 16:29:59 EDT
python-fabulous-0.1.5-4.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/python-fabulous-0.1.5-4.fc17
Comment 13 Fedora Update System 2012-04-25 16:45:50 EDT
python-fabulous-0.1.5-4.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-fabulous-0.1.5-4.el6
Comment 14 Fedora Update System 2012-04-26 15:26:58 EDT
python-fabulous-0.1.5-4.fc17 has been pushed to the Fedora 17 testing repository.
Comment 15 Fedora Update System 2012-05-22 11:42:05 EDT
python-fabulous-0.1.5-4.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 16 Fedora Update System 2012-05-26 03:47:18 EDT
python-fabulous-0.1.5-4.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.